## mingw-w64-jom-1.1.3-3.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(jom LANGUAGES CXX)

set(CMAKE_AUTOMOC ON)
enable_testing()

# where to look first for cmake modules
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules;${CMAKE_MODULE_PATH}")

find_package(Qt5 5.2.0 REQUIRED COMPONENTS Core)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
add_subdirectory(src/jomlib)
add_subdirectory(src/app)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
find_package(Qt5 5.2.0 REQUIRED COMPONENTS Test)
add_executable(jom-test
  tests.cpp tests.h)

target_link_libraries(jom-test PRIVATE jomlib Qt5::Test)

add_test(NAME jom-test COMMAND jom-test)

add_custom_command(TARGET jom-test POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/makefiles $<TARGET_FILE_DIR:jom-test>/makefiles
)

=== src/app/CMakeLists.txt ===
add_executable(jom
  application.cpp
  application.h
  main.cpp
  )

set_target_properties(jom PROPERTIES DEBUG_POSTFIX d)
target_link_libraries(jom PRIVATE jomlib)

install(TARGETS jom RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)

=== src/jomlib/CMakeLists.txt ===
add_library(jomlib STATIC
  commandexecutor.cpp
  commandexecutor.h
  dependencygraph.cpp
  dependencygraph.h
  exception.cpp
  exception.h
  fastfileinfo.cpp
  fastfileinfo.h
  filetime.cpp
  filetime.h
  helperfunctions.cpp
  helperfunctions.h
  iocompletionport.cpp
  iocompletionport.h
  jobclient.cpp
  jobclient.h
  jobclientacquirehelper.cpp
  jobclientacquirehelper.h
  jobserver.cpp
  jomprocess.cpp
  jomprocess.h
  macrotable.cpp
  macrotable.h
  makefile.cpp
  makefile.h
  makefilefactory.cpp
  makefilefactory.h
  makefilelinereader.cpp
  makefilelinereader.h
  options.cpp
  options.h
  parser.cpp
  parser.h
  ppexpr_grammar.cpp
  ppexpr_grammar_p.h
  ppexprparser.cpp
  ppexprparser.h
  preprocessor.cpp
  preprocessor.h
  stable.h
  targetexecutor.cpp
  targetexecutor.h
  )

target_include_directories(jomlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(jomlib PUBLIC Qt5::Core)
target_compile_definitions(jomlib PRIVATE
  QT_NO_CAST_FROM_ASCII
  QT_NO_CAST_TO_ASCII
  UNICODE
  )

if(MSVC)
  target_compile_definitions(jomlib PUBLIC
    _CRT_SECURE_NO_WARNINGS
    )
endif()

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=jom
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgdesc="JOM - the parallel make tool for Windows (mingw-w64)"
pkgver=1.1.3
pkgrel=3
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://wiki.qt.io/Jom'
msys2_repository_url="https://codereview.qt-project.org/gitweb?p=qt-labs/jom.git"
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-qt5-base")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("${_realname}-v${pkgver}.tar.gz::https://codereview.qt-project.org/gitweb?p=qt-labs/jom.git;a=snapshot;h=refs/tags/v${pkgver};sf=tgz")
sha256sums=('1207452997f428505203741a4de4bb7b35fb37b357bf56092280c57c8e47d18b')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_CXX_STANDARD=14 \
    "${_extra_config[@]}" \
    ../${_realname}-v${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-v${pkgver}/LICENSE.GPL \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
